/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the HourMinute type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HourMinute{}

// HourMinute struct for HourMinute
type HourMinute struct {
	Hour int32 `json:"hour"`
	Minute int32 `json:"minute"`
}

// NewHourMinute instantiates a new HourMinute object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHourMinute(hour int32, minute int32) *HourMinute {
	this := HourMinute{}
	this.Hour = hour
	this.Minute = minute
	return &this
}

// NewHourMinuteWithDefaults instantiates a new HourMinute object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHourMinuteWithDefaults() *HourMinute {
	this := HourMinute{}
	return &this
}

// GetHour returns the Hour field value
func (o *HourMinute) GetHour() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Hour
}

// GetHourOk returns a tuple with the Hour field value
// and a boolean to check if the value has been set.
func (o *HourMinute) GetHourOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Hour, true
}

// SetHour sets field value
func (o *HourMinute) SetHour(v int32) {
	o.Hour = v
}

// GetMinute returns the Minute field value
func (o *HourMinute) GetMinute() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Minute
}

// GetMinuteOk returns a tuple with the Minute field value
// and a boolean to check if the value has been set.
func (o *HourMinute) GetMinuteOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Minute, true
}

// SetMinute sets field value
func (o *HourMinute) SetMinute(v int32) {
	o.Minute = v
}

func (o HourMinute) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HourMinute) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["hour"] = o.Hour
	toSerialize["minute"] = o.Minute
	return toSerialize, nil
}

type NullableHourMinute struct {
	value *HourMinute
	isSet bool
}

func (v NullableHourMinute) Get() *HourMinute {
	return v.value
}

func (v *NullableHourMinute) Set(val *HourMinute) {
	v.value = val
	v.isSet = true
}

func (v NullableHourMinute) IsSet() bool {
	return v.isSet
}

func (v *NullableHourMinute) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHourMinute(val *HourMinute) *NullableHourMinute {
	return &NullableHourMinute{value: val, isSet: true}
}

func (v NullableHourMinute) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHourMinute) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


